#!/bin/sh

source send_cmd_pipe.sh
source script_parser.sh

insmod /system/vendor/modules/sunxi-reg.ko
dram_size=`script_fetch "dram" "dram_size"`
test_size=`script_fetch "dram" "test_size"`

actual_size=`draminfo size`
factor_N=`cat /proc/ccmu | awk -F: '(NF&&$1~/ *Pll5Ctl.FactorN$/) {print $2}' `
factor_K=`cat /proc/ccmu | awk -F: '(NF&&$1~/ *Pll5Ctl.FactorK$/) {print $2}' `
factor_M=`cat /proc/ccmu | awk -F: '(NF&&$1~/ *Pll5Ctl.FactorM$/) {print $2}' `
let "dram_freq=(24*$factor_N*$factor_K)/$factor_M"

echo "dram_freq=$dram_freq"
echo "config dram_size=$dram_size"M""
echo "actual_size=$actual_size"M""
echo "test_size=$test_size"M""

if [ $actual_size -lt $dram_size ]; then
   SEND_CMD_PIPE_FAIL_EX $3 "size "$actual_size"M"" error"
   exit 0
fi
SEND_CMD_PIPE_MSG $3 "size:$actual_size"M" freq:$dram_freq"MHz""
memtester $test_size"M" 1 > /dev/null 
if [ $? -ne 0 ]; then
    echo "memtest fail"
    SEND_CMD_PIPE_FAIL_EX $3 "size:$actual_size"M" freq:$dram_freq"MHz""
else
    echo "memtest success!"
    SEND_CMD_PIPE_OK_EX $3 "size:$actual_size"M" freq:$dram_freq"MHz""
fi
